/****************************************************************************/
#define STRICT
#include <windows.h>
#define WM_COMM WM_USER + 1

HINSTANCE hInst;   /* current instance */
long FAR PASCAL MainWndProc(HWND, unsigned, WORD, LONG);
int PASCAL WinMain(HINSTANCE, HINSTANCE, LPSTR, int);
BOOL InitApplication(HANDLE);
BOOL InitInstance(HANDLE, int);

int  WINAPI __export SerialStartUphWnd (int, HWND, unsigned);
int  WINAPI __export SerialShutDown (void);
int  WINAPI __export SerialSend (int, LPSTR, int);
int  WINAPI __export SerialOpenPort (int, int, int, unsigned long, int, int, LPSTR, LPSTR);
int  WINAPI __export SerialNotification (int, int);
int  WINAPI __export SerialReceivehWnd (LPSTR, int);
int  WINAPI __export SerialClosePort (int);
int  WINAPI __export SerialDial (int, LPSTR);
int  WINAPI __export SerialDisplayErrors (void);
int  WINAPI __export SerialErrorOn (void);
int  WINAPI __export SerialErrorOff (void);
int  WINAPI __export SerialModemHangup (int);
int  WINAPI __export SerialGetModemRespone (LPSTR);
int  WINAPI __export SerialLowLevelRead (unsigned short, LPSTR);
int  WINAPI __export SerialLowLevelWrite (unsigned short, LPSTR);// unsigned char
int  WINAPI __export SerialXModemTransmit (int, LPSTR);
int  WINAPI __export SerialXModemReceive (int, LPSTR);
int  WINAPI __export SerialCancelTransfer (void);

int iPort, iRecvPort, iBytesrecv, i;
char szAppName[] = "Caller";
char szTest[] = "Data send via DLL";

HANDLE hMem;
LPSTR  lpMem;
/****************************************************************************

    FUNCTION: WinMain(HANDLE, HANDLE, LPSTR, int)

    PURPOSE: calls initialization function, processes message loop

    COMMENTS:

        Windows recognizes this function by name as the initial entry point
        for the program.  This function calls the application initialization
        routine, if no other instance of the program is running, and always
        calls the instance initialization routine. It then executes a message
        retrieval and dispatch loop that is the top-level control structure
        for the remainder of execution. The loop is terminated when a WM_QUIT
        message is received, at which time this function exits the application
        instance by returning the value passed by PostQuitMessage().

        If this function must abort before entering the message loop, it
        returns the conventional value NULL.

****************************************************************************/

int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    MSG msg;                     /* message */

    /* Save the instance handle in static variable, which will be used in
       many subsequent calls from this application to Windows.      */
    hInst = hInstance;
    
    if (!hPrevInstance)                /* Other instances of app running? */
     if (!InitApplication(hInstance))  /* Initialize shared things        */
      return (FALSE);                  /* Exits if unable to initialize   */

    /* Perform initializations that apply to a specific instance */
    if (!InitInstance(hInstance, nCmdShow))
     return (FALSE);

    /* Acquire and dispatch messages until a WM_QUIT message is received. */
    while (GetMessage(&msg,         /* message structure */
        NULL,   /* handle of window receiving the message */
        NULL,   /* lowest message to examine    */
        NULL))  /* highest message to examine   */
    {
        TranslateMessage(&msg);         /* Translates virtual key codes           */
        DispatchMessage(&msg);          /* Dispatches message to window           */
    }
    return (msg.wParam);            /* Returns the value from PostQuitMessage */
    
}

/****************************************************************************

    FUNCTION: InitApplication(HANDLE)

    PURPOSE: Initializes window data and registers window class

****************************************************************************/

BOOL InitApplication(HANDLE hInstance)
{
    WNDCLASS  wc;

 /* Fill in window class structure with parameters that describe the
    main window. */

    wc.style = CS_HREDRAW | CS_VREDRAW; /* Class style(s) */
    wc.lpfnWndProc = MainWndProc;       /* Function to retrieve messages for */
                                        /* windows of this class    */
    wc.cbClsExtra = 0;                  /* No per-class extra data  */
    wc.cbWndExtra = 0;                  /* No per-window extra data */
    wc.hInstance = hInstance;           /* Application that owns the class */
    wc.hIcon = LoadIcon(hInstance, szAppName);
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = GetStockObject(LTGRAY_BRUSH); 
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = szAppName;       /* Name used in call to CreateWindow. */

    /* Register the window class and return success/failure code. */
    return (RegisterClass(&wc));
}

/****************************************************************************

    FUNCTION:  InitInstance(HANDLE, int)

    PURPOSE:  Saves instance handle and creates main window

****************************************************************************/

BOOL InitInstance(HANDLE hInstance, int nCmdShow)
{
    HWND     hWnd;  /* Main window handle */

    /* Create a main window for this application instance.  */

    hWnd = CreateWindow(
        szAppName,      /* See RegisterClass() call  */
        "Test Application RS232 DLL", /* Text for window title bar */
        WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX,
                        /* Window style */
        CW_USEDEFAULT,  /* Default horizontal position */
        CW_USEDEFAULT,  /* Default vertical position   */
        CW_USEDEFAULT,  /* Default width  */
        CW_USEDEFAULT,  /* Default height */
        NULL,           /* Overlapped windows have no parent */
        NULL,           /* Use the window class menu */
        hInstance,      /* This instance owns this window */
        NULL            /* Pointer not needed */
    );

    /* If window could not be created, return "failure" */
    if (!hWnd)
     return (FALSE);

  /* show window minimized; update its client area; and return "success" */
    ShowWindow(hWnd, SW_SHOWMAXIMIZED); /* Show the window        */
    UpdateWindow(hWnd);                 /* Sends WM_PAINT message */ 

    return (TRUE);  /* Returns the value from PostQuitMessage     */
}

/****************************************************************************

    FUNCTION: MainWndProc(HWND, unsigned, WORD, LONG)

****************************************************************************/

LONG FAR PASCAL MainWndProc(HWND hWnd, unsigned message, WORD wParam, LONG lParam)
{

    switch (message)
    {

       case WM_DESTROY:        /* message: window being destroyed */
        SerialShutDown ();
        PostQuitMessage(0);    // close app
       break;

       case WM_COMM:          // data comming in
        iRecvPort = wParam; // port-id is in wparam
        iBytesrecv = LOWORD(lParam); //#bytes in queue is in loword of lparam

        hMem = GlobalAlloc (GHND, iBytesrecv); // allocate memory 
        lpMem = GlobalLock (hMem); // lock memory and get pointer

        i = SerialReceivehWnd (lpMem, iBytesrecv); // read all data
        
        MessageBox (hWnd, lpMem, (LPSTR)"Access to RS232", MB_ICONEXCLAMATION);
        
        GlobalUnlock (hMem); // free memory
        GlobalFree (hMem);
       break;

       case WM_CREATE: // show 'debug window', pass handle and message-id
         SerialStartUphWnd (1, hWnd, WM_COMM);
         iPort = SerialOpenPort(1, 0, 0, 4800, 8, 1, "N", "X");
       break;

       case WM_KEYDOWN:
        if (wParam == VK_F2) // press F2 and send data
        {
         i = SerialSend (iPort, szTest, sizeof (szTest));
         break;
        }
        return (DefWindowProc(hWnd, message, wParam, lParam));
       break;

       default:                /* Passes it on if unproccessed */
        return (DefWindowProc(hWnd, message, wParam, lParam));
    }
    return (NULL);
}
/****************************************************************************/
